unit Trinity;

interface

uses Global, Classes, DIB, DXDraws, DXClass, Windows;

type
  TTrinityText = class
  Private
    FLines: TStringList;
    FLetterNum: Word;
    FLineNum: Word;
    FTrinityFixedInterval: Integer;
    FTrinityRandomInterval: Integer;
    FCursorBlinking: Boolean;
    FNbCursorBlink: Integer;
    FTimer: TDXTimer;
  Public
    constructor Create(WritingSpeed: Integer; Sl: TStrings; Timer: TDXTimer);
    destructor Destroy; Override;
    procedure NewSequence;
    procedure StepIt(Sender: TObject; LagCount: Integer);
  end;

implementation

//-----------------------------------------------------------------------------

constructor TTrinityText.Create(WritingSpeed: Integer; Sl: TStrings; Timer: TDXTimer);
begin
  FLines := TStringList.Create;
  FLines.Clear;
  FLines.AddStrings(Sl);
{  FLines.Add('Wake up Neo...');
  FLines.Add('The matrix has you...');
  FLines.Add('Follow the white rabbit.');
  FLines.Add('Knock, knock, Neo.');}
  FTrinityFixedInterval := 110 - WritingSpeed;
  FTrinityRandomInterval := 5 * FTrinityFixedInterval;
  FTimer := Timer;
end;

//-----------------------------------------------------------------------------

destructor TTrinitytext.Destroy;
begin
  FLines.Free;
end;

//-----------------------------------------------------------------------------

procedure TTrinitytext.NewSequence;
begin
  FLetterNum := 1;
  FLineNum := 0;
  ClearScreen;
  FTimer.Interval := FTrinityFixedInterval;
  FTimer.OnTimer := StepIt;
end;

//-----------------------------------------------------------------------------

procedure TTrinityText.StepIt(Sender: TObject; LagCount: Integer);
var
  Ch: Char;
begin
  if FCursorBlinking then
  begin
    Dec(FNbCursorBlink);
    case (FNbCursorBlink mod 2) of
      0: DrawAlpha(' ', FLetterNum * ALPHA_WIDTH, 3);
      1: DrawAlpha(Chr(127), FLetterNum * ALPHA_WIDTH, 3);
    end;
    if (FNbCursorBlink < 1) then
    begin
      FCursorBlinking := False;
      FTimer.Interval := FTrinityFixedInterval + Random(FTrinityRandomInterval);
    end;
  end
  else begin
    if ((FLines.Count > 0) and (FLetterNum > Length(FLines[FLineNum]))) then
    begin
      Inc(FLineNum);
      FLetterNum := 1;
      ClearScreen;
    end;
    if (FLineNum > FLines.Count - 1) then
      Global.NewSequence
    else begin
      Ch := FLines[FLineNum][FLetterNum];
      if (Ch in [' '..'~']) then
      begin
        DrawAlpha(Ch, FLetterNum * ALPHA_WIDTH, 3);
        Inc(FLetterNum);
        DrawAlpha(Chr(127), FLetterNum * ALPHA_WIDTH, 3);
      end;
      if (FLetterNum > Length(FLines[FLineNum])) then
      begin
        FCursorBlinking := True;
        FNbCursorBlink := 10;
        FTimer.Interval := CURSOR_INTERVAL;
      end
      else
        FTimer.Interval := FTrinityFixedInterval + Random(FTrinityRandomInterval);
    end;
  end;
  UpdateDisplay;
end;


end.

