{
- adapter ou stretcher "trinity write" et "phone sequence" en fonction des resolutions
}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
  DXClass, DXDraws, DIB, Code, Global, Phone, Trinity, IniFiles, XPMan;

type
  TScreenState = (ssCodeEmulator, ssTrinitysTalking, ssPhoneSequence);

  TMainForm = class(TDXForm)
    DXDraw: TDXDraw;
    DXGlyphDib: TDXDIB;
    DXAlphaDib: TDXDIB;
    DXSysfailDib: TDXDIB;
    DXNumDIB: TDXDIB;
    Timer: TDXTimer;
    DXWhiteCircleDIB: TDXDIB;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DeactivateScrnSaver(var Msg: TMsg; var Handled: boolean);
    procedure DXDrawInitialize(Sender: TObject);
    procedure DXDrawFinalize(Sender: TObject);
  public
    ShowFPS: Boolean;
    PhoneSequenceEnabled: Boolean;
    TrinityTextEnabled: Boolean;
    ScreenState: TScreenState;
    Crs: TPoint;
    PhoneSequence: TPhoneSequence;
    TrinityText: TTrinityText;
    CodeEmulator: TCodeEmulator;
    GlyphSurface: TDirectDrawSurface;
    AlphaSurface: TDirectDrawSurface;
    SysFailSurface: TDirectDrawSurface;
    NumSurface: TDirectDrawSurface;
    WhiteCircleSurface: TDirectDrawSurface;
  end;

var
  MainForm: TMainForm;

implementation

uses Config;

{$R *.DFM}

//-----------------------------------------------------------------------------

procedure TMainForm.FormCreate(Sender: TObject);
var
  I: Integer;
  IniFile: TIniFile;
  Sl: TStringList;
begin
  IniFile := TIniFile.Create(CfgFile);
  with IniFile do
  try
    case ReadInteger('Common', 'Resolution', RESOL_DEF) of
      0: begin //800x600
          DXDraw.SurfaceWidth := 800;
          DXDraw.SurfaceHeight := 600;
        end;
      2: begin //1152x864
          DXDraw.SurfaceWidth := 1152;
          DXDraw.SurfaceHeight := 864;
        end;
      3: begin //1280x1024
          DXDraw.SurfaceWidth := 1280;
          DXDraw.SurfaceHeight := 1024;
        end;
      4: begin //1600x1200
          DXDraw.SurfaceWidth := 1600;
          DXDraw.SurfaceHeight := 1200;
        end;
      else begin //1024x768
          DXDraw.SurfaceWidth := 1024;
          DXDraw.SurfaceHeight := 768;
        end;
    end;
    MATRIX_WIDTH := DXDraw.SurfaceWidth div GLYPH_WIDTH;
    MATRIX_HEIGHT := DXDraw.SurfaceHeight div GLYPH_HEIGHT;
    NB_NEW_GLYPH := Round(50 * DXDraw.SurfaceWidth * DXDraw.SurfaceHeight / (1024 * 768));
    NB_ROW_MAX := Round(250 * MATRIX_WIDTH / 85);
    NB_SHORT_ROW := Round(50 * MATRIX_WIDTH / 85);
    SPEED_MAX := 6;
    PHONE_WIDTH := DXDraw.SurfaceWidth div ALPHA_WIDTH;
    PHONE_HEIGHT := DXDraw.SurfaceHeight div ALPHA_HEIGHT;

    ShowFPS := ReadBool('Common', 'ShowFPS', SHOW_FPS_DEF);
    PhoneSequenceEnabled := ReadBool('Phone', 'PhoneSequenceEnabled', PHONE_SEQUENCE_ENABLED_DEF);
    TrinityTextEnabled := ReadBool('Trinity', 'TrinitytextEnabled', TRINITY_TEXT_ENABLED_DEF);
    NbRowMini := ReadInteger('Code', 'CharacterDensity', CHARACTER_DENSITY_DEF) -
      ReadInteger('Code', 'CharacterDensityDelta', CHARACTER_DENSITY_DELTA_DEF);
    NbRowRand := 2 * ReadInteger('Code', 'CharacterDensityDelta', CHARACTER_DENSITY_DELTA_DEF);
    CodeIntervalMini := ReadInteger('Code', 'FallingSpeed', FALLING_SPEED_DEF) -
      ReadInteger('Code', 'FallingSpeedDelta', FALLING_SPEED_DELTA_DEF);
    CodeIntervalRand := 2 * ReadInteger('Code', 'FallingSpeedDelta', FALLING_SPEED_DELTA_DEF);
    NbIterationMini := ReadInteger('Code', 'FallingCodeDuration', FALLING_CODE_DURATION_DEF) -
      ReadInteger('Code', 'FallingCodeDurationDelta', FALLING_CODE_DURATION_DELTA_DEF);
    NbIterationRand := ReadInteger('Code', 'FallingCodeDurationDelta', FALLING_CODE_DURATION_DELTA_DEF);
    ChangingWindowFrequency := 60 - ReadInteger('Code', 'ChangingWindowFrequency', CHANGING_WINDOW_FREQUENCY_DEF);
    FallingEndText := ReadString('Code', 'FallingText', FALLING_TEXT_DEF);

    CodeEmulator := TCodeEmulator.Create(Timer);

    I := 0;
    Sl := TStringList.Create;
    while ValueExists('Trinity', 'Line' + IntTostr(I)) do
    begin
      Sl.Add(ReadString('Trinity', 'Line' + IntToStr(I), ''));
      Inc(I);
    end;
    TrinityText := TTrinityText.Create(ReadInteger('Trinity', 'WritingSpeed', WRITING_SPEED_DEF), Sl, Timer);

    PhoneSequence := TPhoneSequence.Create(
      ReadString('Phone', 'PhoneNumber', PHONE_NUMBER_DEF),
      ReadInteger('Phone', 'FindingNumberSpeed', FINDING_NUMBER_SPEED_DEF),
      Timer);
  finally
    Free;
  end;
  Randomize;
  GetCursorPos(Crs);
  Application.OnMessage := DeactivateScrnSaver;
  DXDraw.Cursor := crNone;
{  case Random(3) of
    0: ScreenState := ssCodeEmulator;
    1: ScreenState := ssTrinitysTalking;
    2: ScreenState := ssPhoneSequence;
  end;
  NewSequence;}
  ScreenState := ssCodeEmulator;
  CodeEmulator.NewSequence;
{  ScreenState := ssTrinitysTalking;
  TrinityText.NewSequence;}
{  ScreenState := ssPhoneSequence;
  PhoneSequence.NewSequence;}
end;

//-----------------------------------------------------------------------------

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Owner: HWnd;
begin
  Owner := GetWindow(Handle, GW_OWNER);
  ShowWindow(Owner, SW_HIDE);
end;

//-----------------------------------------------------------------------------

procedure TMainForm.DeactivateScrnSaver(var Msg: TMsg; var Handled: boolean);
var
  done: boolean;
begin
  if Msg.message = WM_MOUSEMOVE then
    done := (Abs(LOWORD(Msg.lParam) - crs.x) > 200) or
      (Abs(HIWORD(Msg.lParam) - crs.y) > 200)
  else
    done := (Msg.message = WM_KEYDOWN) or (Msg.message = WM_ACTIVATE) or
      (Msg.message = WM_ACTIVATEAPP) or (Msg.message = WM_NCACTIVATE);
  if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_INSERT) then
    Timer.Enabled := not Timer.Enabled
  else if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_DELETE) then
    CodeEmulator.OpenWindow
  else if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_END) then
    case ScreenState of
      ssCodeEmulator: CodeEmulator.EndIt;
      ssTrinitysTalking: TrinityText.EndIt;
      ssPhoneSequence: PhoneSequence.EndIt;
    end
  else if done then
    Close;
end;

//-----------------------------------------------------------------------------

procedure TMainForm.DXDrawInitialize(Sender: TObject);
begin
  Timer.Enabled := True;
  GlyphSurface := TDirectDrawSurface.Create(DXDraw.DDraw);
  GlyphSurface.LoadFromGraphic(DXGlyphDIB.DIB);
  AlphaSurface := TDirectDrawSurface.Create(DXDraw.DDraw);
  AlphaSurface.LoadFromGraphic(DXAlphaDIB.DIB);
  SysFailSurface := TDirectDrawSurface.Create(DXDraw.DDraw);
  SysFailSurface.LoadFromGraphic(DXSysFailDIB.DIB);
  NumSurface := TDirectDrawSurface.Create(DXDraw.DDraw);
  NumSurface.LoadFromGraphic(DXNumDIB.DIB);
  WhiteCircleSurface := TDirectDrawSurface.Create(DXDraw.DDraw);
  WhiteCircleSurface.LoadFromGraphic(DXWhiteCircleDIB.DIB);
end;

//-----------------------------------------------------------------------------

procedure TMainForm.DXDrawFinalize(Sender: TObject);
begin
  Timer.Enabled := False;
  GlyphSurface.Free;
  AlphaSurface.Free;
  SysFailSurface.Free;
  NumSurface.Free;
  WhiteCircleSurface.Free;
end;

//-----------------------------------------------------------------------------

end.

