program Matrix;

uses
  Forms,
  SysUtils,
  Windows,
  Main in 'Main.pas' {MainForm},
  Config in 'Config.pas' {ConfigForm},
  Global in 'Global.pas',
  Phone in 'Phone.pas',
  Trinity in 'Trinity.pas',
  Code in 'Code.pas';

type
  TSSMode = (ssSetPwd, ssPreview, ssConfig, ssRun);

var
  MySem: THandle;
  Arg1, Arg2: string;
  SSMode: TSSMode;

{$E SCR}
{$R *.RES}

begin
  Application.Initialize;
  Application.Title := 'Matrix code';
  MySem := CreateSemaphore(nil, 0, 1, 'SimpleSaverSemaphore');
  if ((MySem <> 0) and (GetLastError = ERROR_ALREADY_EXISTS)) then begin
    CloseHandle(MySem);
    Halt;
  end;
  Arg1 := UpperCase(ParamStr(1));
  Arg2 := UpperCase(ParamStr(2));
  if (Copy(Arg1, 1, 2) = '/A') or (Copy(Arg1, 1, 2) = '-A') or (Copy(Arg1, 1, 1) = 'A') then
    SSMode := ssSetPwd
  else if (Copy(Arg1, 1, 2) = '/P') or (Copy(Arg1, 1, 2) = '-P') or (Copy(Arg1, 1, 1) = 'P') then
    SSMode := ssPreview
  else if (Copy(Arg1, 1, 2) = '/S') or (Copy(Arg1, 1, 2) = '-S') or (Copy(Arg1, 1, 1) = 'S') then
    SSMode := ssRun
  else if (Copy(Arg1, 1, 2) = '/C') or (Copy(Arg1, 1, 2) = '-C') or (Copy(Arg1, 1, 1) = 'C') or (Arg1 = '') then
    SSMode := ssConfig
  else begin
    SSMode := ssRun;
    Halt;
  end;

  if (SSMode = ssRun) then begin
    Application.CreateForm(TMainForm, MainForm);
  end
  else if (SSMode = ssConfig) then
  begin
    Application.CreateForm(TConfigForm, ConfigForm);
  end
  else Halt;
  Application.Run;
  CloseHandle(MySem);
end.

